<?php

//
// Mark Claypool, WPI
// 2017
//

// Based on code by Jeroen van der Gun.
// https://tagpro.eu/?science

// Class to handle maps.
class MapEventHandler extends MapLogReader {

  // Tally the appropriate map tile.
  protected function tileEvent($newX, $y, $tile) {
    global $g_wall_tile;
    global $g_flag_tile;
    global $g_speed_tile;
    global $g_button_tile;
    global $g_powerup_tile;
    global $g_spike_tile;
    global $g_bomb_tile;
    global $g_gate_tile;
    global $g_area;
    $g_area++;

    switch($tile) {
      case self::squareWallTile:
      case self::lowerLeftDiagonalWallTile:
      case self::upperLeftDiagonalWallTile:
      case self::upperRightDiagonalWallTile:
      case self::lowerRightDiagonalWallTile:
        $g_wall_tile++;
        break;
      case self::redFlagTile:
      case self::blueFlagTile:
      case self::neutralFlagTile:
        $g_flag_tile++;
        break;
      case self::neutralSpeedpadTile:
      case self::redSpeedpadTile:
      case self::blueSpeedpadTile:
        $g_speed_tile++;
        break;
      case self::powerupTile:
        $g_powerup_tile++;
        break;
      case self::spikeTile:
        $g_spike_tile++;
        break;
      case self::buttonTile:
        $g_button_tile++;
        break;
      case self::openGateTile:
      case self::closedGateTile:
      case self::redGateTile:
      case self::blueGateTile:
        $g_gate_tile++;
        break;
      case self::bombTile:
        $g_bomb_tile++;
        break;
      default:
        break;
    }
  }

  // Constructor.
  public function __construct() {
    global $g_match;
    parent::__construct(base64_decode($g_match->map->tiles),
                        $g_match->map->width);
  }
}

?>
